'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _createChainedFunction = require('./utils/createChainedFunction');

var _createChainedFunction2 = _interopRequireDefault(_createChainedFunction);

var _FormControlMixin = require('./mixins/FormControlMixin.js');

var _FormControlMixin2 = _interopRequireDefault(_FormControlMixin);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Checkbox = _react2.default.createClass({
    displayName: 'Checkbox',

    mixins: [_FormControlMixin2.default],
    propTypes: {
        id: _react2.default.PropTypes.string,
        name: _react2.default.PropTypes.string,
        inline: _react2.default.PropTypes.bool,
        title: _react2.default.PropTypes.string,
        disabled: _react2.default.PropTypes.bool,
        checked: _react2.default.PropTypes.bool,
        onClick: _react2.default.PropTypes.func,
        onChange: _react2.default.PropTypes.func,
        value: _react2.default.PropTypes.bool
    },
    getCheckStateFromProps: function getCheckStateFromProps() {
        // if checked props given, return checked props, else return value props
        var _props = this.props;
        var checked = _props.checked;
        var value = _props.value;

        var check = checked;
        if (check === undefined) {
            check = value;
        }
        return check;
    },

    contextTypes: {
        formGroup: _react2.default.PropTypes.object
    },
    getDefaultProps: function getDefaultProps() {
        return {
            inline: false,
            disabled: false
        };
    },
    getInitialState: function getInitialState() {
        return {
            checked: this.getCheckStateFromProps()
        };
    },
    handleChange: function handleChange(event) {
        if (this.props.disabled) {
            return;
        }

        var checked = !this.state.checked;

        this.setState({
            checked: checked
        });

        var onChange = this.props.onChange;

        onChange && onChange(checked);
    },
    render: function render() {
        var _props2 = this.props;
        var type = _props2.type;
        var inline = _props2.inline;
        var title = _props2.title;
        var name = _props2.name;
        var disabled = _props2.disabled;
        var className = _props2.className;
        var children = _props2.children;
        var onChange = _props2.onChange;

        var props = _objectWithoutProperties(_props2, ['type', 'inline', 'title', 'name', 'disabled', 'className', 'children', 'onChange']);

        var classes = (0, _classnames2.default)({
            'checkbox-inline': inline
        }, className);

        var checkboxClasses = (0, _classnames2.default)({
            'checker': true,
            'disabled': disabled
        });

        var input = _react2.default.createElement(
            'span',
            { className: (0, _classnames2.default)({
                    'checked': this.state.checked
                }) },
            _react2.default.createElement('input', {
                type: 'checkbox',
                name: name,
                disabled: disabled,
                onChange: this.handleChange,
                defaultChecked: this.state.checked
            })
        );

        return _react2.default.createElement(
            'label',
            { className: classes },
            _react2.default.createElement(
                'div',
                {
                    className: checkboxClasses,
                    role: 'checkbox'
                },
                input
            ),
            title || children
        );
    }
});

exports.default = Checkbox;